package main;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import de.uni_kassel.pmss2010.converter.Temperature;

public class TemperatureController
{
   private Temperature tempModel;
   private CelsiusFahrenheitConverterGUI celsiusGui;
   private ConvertSliderGUI sliderGui;

   public TemperatureController()
   {
   }
   
   public void start()
   {
      // Create model
      tempModel = new Temperature();
      
      // Create gui
      celsiusGui = new CelsiusFahrenheitConverterGUI();
      sliderGui = new ConvertSliderGUI(); 
      
      // Register some listeners
      tempModel.addPropertyChangeListener(Temperature.PROPERTY_TEMPERATURE_VALUE, new PropertyChangeListener() {
         
         @Override
         public void propertyChange(PropertyChangeEvent arg0)
         {
            refreshUI();
            
         }
      });
      
      celsiusGui.getToCelsiusButton().addActionListener(new ActionListener() {
         
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            String value = celsiusGui.getValueField().getText();
            tempModel.convertToCelsius(Float.valueOf(value));
         }
      });
      
      celsiusGui.getToFahrenheitButton().addActionListener(new ActionListener() {
         
         @Override
         public void actionPerformed(ActionEvent arg0)
         {
            String value = celsiusGui.getValueField().getText();
            tempModel.convertToFahrenheit(Float.valueOf(value));
         }
      });
      
      sliderGui.getSlider().addChangeListener(new ChangeListener() {
         
         @Override
         public void stateChanged(ChangeEvent arg0)
         {
            int value = sliderGui.getSlider().getValue();
            tempModel.convertToFahrenheit(Float.valueOf(value));
         }
      });
   }
   
   private void refreshUI()
   {
      float temperatureValue = tempModel.getTemperatureValue();
      celsiusGui.getConvertedField().setText(String.valueOf(temperatureValue));
   }
}
